"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.
"
"{ Package: 'stx:libjava' }"

Object subclass:#JavaObjectDictionary
	instanceVariableNames:'dictionary'
	classVariableNames:'Instance'
	poolDictionaries:''
	category:'Languages-Java-Support'
!

!JavaObjectDictionary class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.

"
! !

!JavaObjectDictionary class methodsFor:'instance creation'!

instance
    Instance ifNil: [
        Instance := self basicNew initialize.
    ].
    ^ Instance.

    "Created: / 09-01-2011 / 20:48:16 / Jan Kurs <kurs.jan@post.cz>"
!

new 
    "Currently singleton but in future Query may be more suitable"
    ^ self instance.

    "Created: / 09-01-2011 / 20:48:16 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaObjectDictionary methodsFor:'accessing'!

hasReflection: stClassName
    "return true if stClassName has reflection in Java World"
    ^ (dictionary at: stClassName ifAbsent:  [ nil ]) notNil

    "Created: / 17-01-2011 / 19:20:58 / kursjan <kursjan@fit.cvut.cz>"
!

reflectionOf: stClassName
    ^ dictionary at: stClassName ifAbsent:  [ NoReflectionObject new ]

    "Created: / 09-01-2011 / 21:03:24 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 17-01-2011 / 10:39:43 / kursjan <kursjan@fit.cvut.cz>"
! !

!JavaObjectDictionary methodsFor:'adding & removing'!

flush
    dictionary removeAll.

    "Created: / 09-01-2011 / 21:44:04 / Jan Kurs <kurs.jan@post.cz>"
!

registerJavaObject: aJavaClass toStObject: aStObject
    dictionary at: aStObject name asSymbol put: aJavaClass.

    "Created: / 09-01-2011 / 21:40:00 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaObjectDictionary methodsFor:'initialization'!

initialize
    "Use StCounter instead of Counter"
    dictionary := IdentityDictionary new.

    "Modified: / 09-01-2011 / 21:36:58 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaObjectDictionary class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libjava/JavaObjectDictionary.st,v 1.2 2011-11-24 11:34:35 cg Exp $'
!

version_SVN
    ^ 'Id: JavaObjectDictionary.st,v 1.1 2011/08/18 19:06:53 vrany Exp '
! !
